
#pragma once

#include <windows.h>


#ifdef ARCHIVEMANAGER_EXPORTS
#define ARCHIVEMANAGER_API __declspec(dllexport)
#else
//#define ARCHIVEMANAGER_API __declspec(dllimport)
#define ARCHIVEMANAGER_API 
#endif

typedef LPVOID HARCHIVE;
typedef int ArchiveType;

#if defined(__cplusplus)
extern "C" {
#endif

/* Anti 7-zip common/types.h include */
#ifndef __COMMON_TYPES_H
typedef unsigned __int32 UInt32;
typedef unsigned __int64 UInt64;
#endif

typedef BOOL (__cdecl *ArchiveExtractCallback)(LPVOID param, UInt64 completed, UInt64 total);

ARCHIVEMANAGER_API DWORD WINAPI GetAMLastError();
ARCHIVEMANAGER_API DWORD WINAPI GetAMVersion();
ARCHIVEMANAGER_API BOOL WINAPI Get7zVersion(WCHAR *version, DWORD size);

ARCHIVEMANAGER_API HARCHIVE WINAPI OpenArchive(const WCHAR *);
ARCHIVEMANAGER_API HARCHIVE WINAPI OpenArchiveAs(const WCHAR *, ArchiveType type);
ARCHIVEMANAGER_API HARCHIVE WINAPI OpenArchiveFromHandle(HANDLE hFile);
ARCHIVEMANAGER_API HARCHIVE WINAPI OpenArchiveAsFromHandle(HANDLE hFile, ArchiveType type);
ARCHIVEMANAGER_API BOOL WINAPI CloseArchive(HARCHIVE hArchive);

ARCHIVEMANAGER_API ArchiveType WINAPI GetArchiveType(HARCHIVE hArchive);

ARCHIVEMANAGER_API UInt32 GetFileCount(HARCHIVE hArchive);
ARCHIVEMANAGER_API UInt64 GetFileSizeFromArchive(HARCHIVE hArchive, UInt32 index);
ARCHIVEMANAGER_API DWORD GetFileNameFromArchive(HARCHIVE hArchive, UInt32 index, WCHAR *str, DWORD strSize);
ARCHIVEMANAGER_API DWORD GetFilePathFromArchive(HARCHIVE hArchive, UInt32 index, WCHAR *str, DWORD strSize);

ARCHIVEMANAGER_API BOOL ExtractToFile(HARCHIVE hArchive, UInt32 index, const WCHAR *path, ArchiveExtractCallback, LPVOID param);
ARCHIVEMANAGER_API BOOL ExtractToMemory(HARCHIVE hArchive, UInt32 index, BYTE *buff, UInt32 buffSize, ArchiveExtractCallback, LPVOID param);
ARCHIVEMANAGER_API BOOL ExtractToHandle(HARCHIVE hArchive, UInt32 index, HANDLE handle, ArchiveExtractCallback, LPVOID param);

#if defined(__cplusplus)
}	// close: extern "C"
#endif


/* zip, lzh, cab, rar, iso */
#define ARCHIVE_NONE 0
#define ARCHIVE_ZIP 1
#define ARCHIVE_LZH 2
#define ARCHIVE_CAB 3
#define ARCHIVE_RAR 4
#define ARCHIVE_ISO 5


#define ARCHIVE_MANAGER_VERSION (HIWORD(0x0000) | LOWORD(0x0001))


