
#include "stdafx.h"
#include "ArchiveManager.h"
#include "ExtractCallback.h"

#include "Common/StringConvert.h"
#include "Windows/PropVariant.h"
#include "Windows/PropVariantConversions.h"
#include "Windows/DLL.h"


CExtractCallback::CExtractCallback()
	: Result_(NArchive::NExtract::NOperationResult::kOK)
	, totalSize_(0)
	, ExtractCallbackParam_(NULL)
	, ExtractCallback_(NULL)
{
}

void CExtractCallback::Init(IInArchive *archive)
{
	archive_ = archive;
}

STDMETHODIMP CExtractCallback::SetTotal(UInt64 size)
{
	totalSize_ = size;
	if (ExtractCallback_ != NULL) {
		return ExtractCallback_(ExtractCallbackParam_, 0, size) ? S_OK : E_ABORT;
	}
	return S_OK;
}

STDMETHODIMP CExtractCallback::SetCompleted(const UInt64 * value)
{
	if (ExtractCallback_ != NULL) {
		return ExtractCallback_(ExtractCallbackParam_, value != NULL ? *value : 0 , totalSize_) ? S_OK : E_ABORT;
	}
	return S_OK;
}

STDMETHODIMP CExtractCallback::GetStream(UInt32 index, ISequentialOutStream **outStream, Int32 askExtractMode)
{
	*outStream = OutStream_.Detach();
	return S_OK;
}

STDMETHODIMP CExtractCallback::PrepareOperation(Int32 askExtractMode)
{
	return S_OK;
}

STDMETHODIMP CExtractCallback::SetOperationResult(Int32 resultEOperationResult)
{
	Result_ = resultEOperationResult;
	return S_OK;
}
