#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <share.h>

#include "ffrutils.h"

VOID dbgoutput(char *formatstr,...)
{
	va_list			argp;
	FILE			*fp = NULL;
	char			szContext[64];
	SYSTEMTIME		st;
	wchar_t			filename[MAX_PATH];

	if (ffrutilsopt.debug == FFRUTILS_DEBUG_NONE) return;

	GetLocalTime(&st);

	// date,time and tid
	_snprintf_s(szContext, _countof(szContext), _TRUNCATE, "%04d-%02d-%02d %02d:%02d:%02d [%X] ",
		st.wYear, st.wMonth, st.wDay,
		st.wHour, st.wMinute, st.wSecond, 
		GetCurrentThreadId());

	// filename
	if (ffrutilsopt.debug & FFRUTILS_DEBUG_LOG)
	{
		_snwprintf_s(filename, _countof(filename), _TRUNCATE, L"%s\\debug.log", ffrutilsopt.debug_dir);
		fp = _wfsopen(filename, L"a", _SH_DENYNO);
	}

	//
	// output
	//
	va_start(argp,formatstr);

	if (ffrutilsopt.debug & FFRUTILS_DEBUG_DISP)
		vfprintf(stdout,formatstr,argp);
	
	if (ffrutilsopt.debug & FFRUTILS_DEBUG_LOG)
	{
		if (NULL != fp)
		{
			fprintf(fp,"%s ",szContext);
			vfprintf(fp,formatstr,argp);
		}

	}
	va_end(argp);

	if (fp) fclose(fp);


	return;
}